package com.tptj.demo.hg.resource.repository.factory.provider;

import com.fr.config.Identifier;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.io.config.CommonRepoConfig;
import com.fr.io.context.info.GetConfig;
import com.fr.io.context.info.SetConfig;
import com.fr.stable.StringUtils;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/7/20
 **/
public class DemoConfig extends CommonRepoConfig {

    private static final String ROOT = "root";

    public DemoConfig() {
        super(DemoFactory.IDENTITY);
    }

    @Identifier(ROOT)
    private Conf<String> root = Holders.simple(StringUtils.EMPTY);

    @GetConfig(ROOT)
    public String getRoot() {
        return root.get();
    }

    @SetConfig(ROOT)
    public void setRoot( String root) {
        this.root.set( root );
    }

    @Override
    public DemoConfig clone() throws CloneNotSupportedException {
        DemoConfig obj = (DemoConfig) super.clone();
        obj.root = (Conf<String>) root.clone();
        return obj;
    }
}
