package com.tptj.demo.hg.resource.repository.factory.provider;

import com.fr.io.repository.FineFileEntry;
import com.fr.io.repository.base.BaseResourceRepository;
import com.fr.io.repository.base.fs.FileSystemRepository;
import com.fr.stable.Filter;
import com.fr.workspace.resource.ResourceIOException;

import java.io.InputStream;
import java.net.URL;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/7/20
 **/
public class DemoRepository extends BaseResourceRepository {
    private String root;
    public DemoRepository(String name, String work_root, String root) {
        super(name, work_root);
        this.root = root;
    }

    @Override
    public boolean copyFile( String from, String to ) throws ResourceIOException {
        return FileSystemRepository.getSingleton().copyFile(from, to);
    }

    @Override
    public String getSeparator() {
        return FileSystemRepository.getSingleton().getSeparator();
    }

    @Override
    public FineFileEntry getEntry(String path) {
        return FileSystemRepository.getSingleton().getEntry(path);
    }

    @Override
    public FineFileEntry[] listEntry(String path) {
        return FileSystemRepository.getSingleton().listEntry(path);
    }

    @Override
    public URL getResource(String path) {
        return FileSystemRepository.getSingleton().getResource(path);
    }

    @Override
    public InputStream read(String path) throws ResourceIOException {
        return FileSystemRepository.getSingleton().read(path);
    }

    @Override
    public void write(String path, byte[] bytes) {
        FileSystemRepository.getSingleton().write(path,bytes);
    }

    @Override
    public boolean createFile(String path) {
        return FileSystemRepository.getSingleton().createFile(path);
    }

    @Override
    public boolean createDirectory(String path) {
        return FileSystemRepository.getSingleton().createDirectory(path);
    }

    @Override
    public boolean delete(String path) {
        return FileSystemRepository.getSingleton().delete(path);
    }

    @Override
    public boolean exist(String path) {
        return FileSystemRepository.getSingleton().exist(path);
    }

    @Override
    public String[] list(String path, Filter<String> filter) {
        return FileSystemRepository.getSingleton().list(path,filter);
    }

    @Override
    public boolean isDirectory(String path) {
        return FileSystemRepository.getSingleton().isDirectory(path);
    }

    @Override
    public long lastModified(String path) {
        return FileSystemRepository.getSingleton().lastModified(path);
    }

    @Override
    public long length(String path) {
        return FileSystemRepository.getSingleton().length(path);
    }

    @Override
    public void shutDown() {
        FileSystemRepository.getSingleton().shutDown();
    }

    @Override
    public String getIdentity() {
        return DemoFactory.IDENTITY;
    }
}
