/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/7/20
 **/
!(function () {
    BI.config("dec.constant.intelligence.cluster.file.server", function (items) {
        items.push({
            value: "DEMO",
            id: "decision-intelligence-cluster-file-demo",
            text: "DEMO REPOSITORY",
            cardType: "dec.intelligence.cluster.file.demo"
        });
        return items;
    });
    var LABEL_WIDTH = 116, EDITOR_WIDTH = 300;
    var DEMO = BI.inherit(BI.Widget, {
        props: {
            baseCls: "dec-cluster-demo",
            value: {}
        },
        _store: function () {
            return BI.Models.getModel("dec.model.intelligence.cluster.file.demo", {
                value: this.options.value
            });
        },

        watch: {},

        render: function () {
            var self = this, o = this.options;
            return {
                type: "bi.vertical",
                tgap: 15,
                items: [
                    {
                        type: "dec.label.editor.item",
                        textWidth: LABEL_WIDTH,
                        editorWidth: EDITOR_WIDTH,
                        watermark: BI.i18nText("Dec-Please_Input"),
                        text: "ROOT",
                        value: this.model.root,
                        ref: function (_ref) {
                            self.rootRow = _ref;
                        },
                        listeners: [{
                            eventName: BI.Editor.EVENT_CHANGE,
                            action: function () {
                                self.store.setRoot(this.getValue());
                            }
                        }]
                    }]
            };
        },
        getValue: function () {
            return {
                root: this.model.root
            };
        },
        validation: function () {
            var valid = true, root = this.model.root;
            if (BI.isEmpty(root)) {
                this.rootRow.showError(BI.i18nText("Dec-Error_Null"));
                valid = false;
            }
            return valid;
        }
    });
    BI.shortcut("dec.intelligence.cluster.file.demo", DEMO);
    var Model = BI.inherit(Fix.Model, {
        state: function () {
            var val = this.options.value;
            return {
                root: val.root
            };
        },
        computed: {
            encodingArray: function () {
                return BI.map(DecCst.EncodeConstants.ENCODING_ARRAY, function (i, v) {
                    return {
                        value: v
                    };
                });
            }
        },
        actions: {
            setRoot: function (v) {
                this.model.root = v;
            }
        }
    });
    BI.model("dec.model.intelligence.cluster.file.demo", Model);
})();